#coding: utf-8
import ssl
import time

import wx
from pubsub import pub
import websocket


class ClientWebSocket():
    def __init__(self):
        self.ws = None                                                                       # websocket 对象
        self.wsUrl = "ws://api-test.vandyo.com/mirror/websocket/"                            # webosocket 连接地址
        self.wsCode = "868142043390091"                                                      # 连接编号
        self.isEnableTrace = 0                                                               # 是否显示websocket连接信息 0：否 1：是

    def setWsUrl(self,data):
        self.wsUrl = data
    def setWsCode(self,data):
        self.wsCode = data

    def getWs(self):
        return self.ws

    def connect(self):
        if self.isEnableTrace == 1:
            websocket.enableTrace(True)
        self.ws = websocket.WebSocketApp(self.wsUrl + self.wsCode,
                                    on_open=self.on_open,
                                    on_message=self.on_message,
                                    on_error=self.on_error,
                                    on_close=self.on_close)
        self.ws.run_forever()

    def on_message(self, message):
        # print("收到消息：" + message)
        wx.CallAfter(pub.sendMessage, "msgRev", msg=message)

    def on_error(self, error):
        print(error)

    def on_close(self):
        curTime = self.getCurTime()
        print(curTime + "websocket 已经断开！！！")

    def on_open(self):
        curTime = self.getCurTime()
        print(curTime + "websocket 已连接......")
        print(self.wsUrl + self.wsCode)

    ##################################################
    #      发送消息
    ##################################################
    def sendMsg(self,msg):
        self.ws.send(msg)

    ##################################################
    #      关闭websocket
    ##################################################
    def close(self):
        self.ws.close()

    ####################################################
    #      获取当前时间
    ####################################################
    def getCurTime(self):
        timeCur = int(time.time() * 1000)
        timeArray = time.localtime(timeCur / 1000)
        timeCur = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
        timeCur = "[" + timeCur + "]  "
        return timeCur

if __name__ == "__main__":
    ClientWebSocket().connect()

